## hidapi 0.15.0

=== mac/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4.3...3.25 FATAL_ERROR)

list(APPEND HIDAPI_PUBLIC_HEADERS "hidapi_darwin.h")

add_library(hidapi_darwin
    ${HIDAPI_PUBLIC_HEADERS}
    hid.c
)

find_package(Threads REQUIRED)

target_link_libraries(hidapi_darwin
    PUBLIC hidapi_include
    PRIVATE Threads::Threads
    PRIVATE "-framework IOKit" "-framework CoreFoundation"
)

set_target_properties(hidapi_darwin
    PROPERTIES
        EXPORT_NAME "darwin"
        OUTPUT_NAME "hidapi"
        VERSION ${PROJECT_VERSION}
        SOVERSION ${PROJECT_VERSION_MAJOR}
        FRAMEWORK_VERSION ${PROJECT_VERSION_MAJOR}
        PUBLIC_HEADER "${HIDAPI_PUBLIC_HEADERS}"
)

if(NOT CMAKE_VERSION VERSION_LESS 3.17)
    option(HIDAPI_USE_LEGACY_COMPATIBILITY_VERSION "Legacy Autotools build system hard-coded 1.0.0 for compatibility version" FALSE)
    if(HIDAPI_USE_LEGACY_COMPATIBILITY_VERSION)
        # TODO: v1: remove this workaround
        set_target_properties(hidapi_darwin
            PROPERTIES
                MACHO_COMPATIBILITY_VERSION "1.0.0"
                MACHO_CURRENT_VERSION "1.0.0"
        )
    else()
        set_target_properties(hidapi_darwin
            PROPERTIES
                MACHO_COMPATIBILITY_VERSION ${PROJECT_VERSION_MAJOR}
        )
    endif()
endif()

# compatibility with find_package()
add_library(hidapi::darwin ALIAS hidapi_darwin)
# compatibility with raw library link
add_library(hidapi ALIAS hidapi_darwin)

set(PUBLIC_HEADER_DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}")
if(NOT CMAKE_FRAMEWORK)
    set(PUBLIC_HEADER_DESTINATION "${PUBLIC_HEADER_DESTINATION}/hidapi")
endif()

if(HIDAPI_INSTALL_TARGETS)
    install(TARGETS hidapi_darwin EXPORT hidapi
        LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
        ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
        FRAMEWORK DESTINATION "${CMAKE_INSTALL_LIBDIR}"
        PUBLIC_HEADER DESTINATION "${PUBLIC_HEADER_DESTINATION}"
    )
endif()

hidapi_configure_pc("${PROJECT_ROOT}/pc/hidapi.pc.in")

=== subprojects/hidapi_build_cmake/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.3...3.25 FATAL_ERROR)
project(hidapi LANGUAGES C)

file(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/root")

foreach(ROOT_ELEMENT CMakeLists.txt hidapi src windows linux mac libusb pc VERSION)
  file(COPY "${CMAKE_CURRENT_LIST_DIR}/../../${ROOT_ELEMENT}" DESTINATION "${CMAKE_CURRENT_BINARY_DIR}/root/")
endforeach()

add_subdirectory("${CMAKE_CURRENT_BINARY_DIR}/root" hidapi_root)

=== windows/test/CMakeLists.txt ===
add_executable(hid_report_reconstructor_test hid_report_reconstructor_test.c)
set_target_properties(hid_report_reconstructor_test
    PROPERTIES
        C_STANDARD 11
        C_STANDARD_REQUIRED TRUE
)

target_link_libraries(hid_report_reconstructor_test
     PRIVATE hidapi_include hidapi_winapi
)

# Each test case requires 2 files:
# <name>.pp_data - textual representation of HIDP_PREPARSED_DATA;
# <name>_expected.rpt_desc - reconstructed HID Report Descriptor out of .pp_data file;
#
# (Non-required by test):
# <name>_real.dpt_desc - the original report rescriptor used to create a test case;
set(HID_DESCRIPTOR_RECONSTRUCT_TEST_CASES
     046D_C52F_0001_000C
     046D_C52F_0001_FF00
     046D_C52F_0002_0001
     046D_C52F_0002_FF00
     17CC_1130_0000_FF01
     046D_0A37_0001_000C
     046A_0011_0006_0001
     046D_C077_0002_0001
     046D_C283_0004_0001
     046D_B010_0006_0001
     046D_B010_0002_FF00
     046D_B010_0002_0001
     046D_B010_0001_FF00
     046D_B010_0001_000C
     046D_C534_0001_000C
     046D_C534_0001_FF00
     046D_C534_0002_0001
     046D_C534_0002_FF00
     046D_C534_0006_0001
     046D_C534_0080_0001
     047F_C056_0001_000C
     047F_C056_0003_FFA0
     047F_C056_0005_000B
     045E_02FF_0005_0001
     1532_00A3_0002_0001
)

set(CMAKE_VERSION_SUPPORTS_ENVIRONMENT_MODIFICATION "3.22")

if(HIDAPI_ENABLE_ASAN AND MSVC)
     if(CMAKE_VERSION VERSION_LESS CMAKE_VERSION_SUPPORTS_ENVIRONMENT_MODIFICATION)
          message("CTest/ASAN: Make sure to run ctest from MSVC Command Prompt")
     endif()
endif()

foreach(TEST_CASE ${HID_DESCRIPTOR_RECONSTRUCT_TEST_CASES})
     set(TEST_PP_DATA "${CMAKE_CURRENT_LIST_DIR}/data/${TEST_CASE}.pp_data")
     if(NOT EXISTS "${TEST_PP_DATA}")
          message(FATAL_ERROR "Missing '${TEST_PP_DATA}' file for '${TEST_CASE}' test case")
     endif()
     set(TEST_EXPECTED_DESCRIPTOR "${CMAKE_CURRENT_LIST_DIR}/data/${TEST_CASE}_expected.rpt_desc")
     if(NOT EXISTS "${TEST_EXPECTED_DESCRIPTOR}")
          message(FATAL_ERROR "Missing '${TEST_EXPECTED_DESCRIPTOR}' file for '${TEST_CASE}' test case")
     endif()

     add_test(NAME "WinHidReportReconstructTest_${TEST_CASE}"
          COMMAND hid_report_reconstructor_test "${TEST_PP_DATA}" "${TEST_EXPECTED_DESCRIPTOR}"
          WORKING_DIRECTORY "$<TARGET_FILE_DIR:hidapi_winapi>"
     )
     if(HIDAPI_ENABLE_ASAN)
          if(MSVC)
               if(NOT CMAKE_VERSION VERSION_LESS CMAKE_VERSION_SUPPORTS_ENVIRONMENT_MODIFICATION)
                    get_filename_component(MSVC_BUILD_TOOLS_DIR "${CMAKE_LINKER}" DIRECTORY)
                    set_property(TEST "WinHidReportReconstructTest_${TEST_CASE}" PROPERTY ENVIRONMENT_MODIFICATION "PATH=path_list_append:${MSVC_BUILD_TOOLS_DIR}")
               endif()
          endif()
          set_property(TEST "WinHidReportReconstructTest_${TEST_CASE}" PROPERTY ENVIRONMENT "ASAN_SAVE_DUMPS=AsanDump_${TEST_CASE}.dmp")
     endif()
endforeach()

=== debian/changelog ===
hidapi (0.15.0-2) unstable; urgency=medium

  [ Pino Toscano ]
  * kFreeBSD was discontinued, so:
    - drop the libusb2-dev build dependency
    - drop the kfreebsd-any architecture from the libhidapi-dev binary package
    - drop the libhidapi0 binary package
  * Add support for Hurd:
    - enable the libusb-1.0-0-dev build dependency on any architecture
    - build the libhidapi-dev, and libhidapi-libusb0 binary packages on any
      architecture

 -- Scott Talbert <swt@techie.net>  Mon, 18 Aug 2025 19:06:09 -0400

hidapi (0.15.0-1) unstable; urgency=medium

  * Build with cmake (Closes: #1104999)
  * d/control: wrap-and-sort
  * d/control: BD pkg-config -> pkgconf
  * Update to new upstream release 0.15.0
  * d/copyright: update to remove FSF address
  * d/control: update Standards-Version to 4.7.2 (no changes needed)

 -- Scott Talbert <swt@techie.net>  Sun, 10 Aug 2025 14:26:53 -0400

=== debian/control ===
Source: hidapi
Priority: optional
Maintainer: Scott Talbert <swt@techie.net>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 libudev-dev [linux-any],
 libusb-1.0-0-dev,
 pkgconf,
Standards-Version: 4.7.2
Section: libs
Homepage: https://github.com/libusb/hidapi
Vcs-Git: https://salsa.debian.org/debian/hidapi.git
Vcs-Browser: https://salsa.debian.org/debian/hidapi
Rules-Requires-Root: no

Package: libhidapi-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libhidapi-hidraw0 (= ${binary:Version}) [linux-any],
 libhidapi-libusb0 (= ${binary:Version}),
 ${misc:Depends},
Description: Multi-Platform library for communication with HID devices (development files)
 HIDAPI is a multi-platform library enabling applications to easily
 interface with Bluetooth and USB HID-class devices.
 .
 This package contains the files needed to compile and link programs which
 use HIDAPI.

Package: libhidapi-libusb0
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Multi-Platform library for communication with HID devices (libusb backend)
 HIDAPI is a multi-platform library enabling applications to easily
 interface with Bluetooth and USB HID-class devices.
 .
 This package contains the libusb-based implementation of HIDAPI.

Package: libhidapi-hidraw0
Architecture: linux-any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Multi-Platform library for communication with HID devices (hidraw backend)
 HIDAPI is a multi-platform library enabling applications to easily
 interface with Bluetooth and USB HID-class devices.
 .
 This package contains the hidraw-based implementation of HIDAPI.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem=cmake --without autoreconf

=== debian/watch ===
version=4
opts="uversionmangle=s/\.?-rc/~rc/,dversionmangle=s/\+.*dfsg$//" \
https://github.com/libusb/hidapi/tags .*/hidapi-?(\d\S*)\.tar\.gz
